/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg.springbootmockmvc;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 *
 * @author omozegieaziegbe
 */
@RestController
@RequestMapping("/api")
public class ProductController {

    @GetMapping("/product")
    public String product() {
        // Construct a JSON string (for simplicity, using a hardcoded string)
        String jsonString = "{\"name\": \"Real World Java EE Patterns\"}";
        return jsonString;
    }

    @GetMapping("/strings")
    public List<String> returnList() {
        return Arrays.asList("The Book of CSS3", "Core HTML5 Canvas", "Pro JavaScript for Web Apps");
    }

    @GetMapping("/stringmap")
    public Map<String, String> returnMap() {
        Map<String, String> stringMap = new HashMap<>();

        stringMap.put("1", "Pro JavaScript for Web Apps");
        stringMap.put("2", "JavaScript Enlightenment");
        stringMap.put("3", "Real World Java EE Patterns");

        return stringMap;
    }

    @GetMapping("/products")
    public List<Product> returnProductList() {

        // Creating a List of Product entities
        List<Product> productList = new ArrayList<>();

        // Adding products to the List
        productList.add(new Product(1, "The Book of CSS3", 50.00));
        productList.add(new Product(2, "JavaScript and JQuery", 70.00));
        productList.add(new Product(3, "Core HTML5 Canvas", 90.00));

        return productList;
    }

    @GetMapping("/productmap")
    public Map<Integer, Product> returnProductMap() {

        // Creating a Map of Product entities with product IDs as keys
        Map<Integer, Product> productMap = new HashMap<>();

        // Adding products to the map
        Product product1 = new Product(1, "Laptop", 999.99);
        Product product2 = new Product(2, "Smartphone", 599.99);

        productMap.put(product1.getId(), product1);
        productMap.put(product2.getId(), product2);

        return productMap;
    }

}
